freeslot("MT_SHADOWBOOST", "sfx_shbost", "S_PLAY_SHADOWAIRBOOST")
states[S_PLAY_SHADOWAIRBOOST] = {SPR_PLAY, FF_SPR2SUPER|A|SPR2_RUN_, -1, nil, 0, 0, S_PLAY_SHADOWAIRBOOST}

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and (player.cmd.buttons & BT_CUSTOM1)
and not player.shadowboost
and player.shadowboostgauge > 0
and not player.powers[pw_carry]
and player.mo.state != S_PLAY_SHADOWCSPEAR
and player.mo.state != S_PLAY_SHADOWCBLAST1
and player.mo.state != S_PLAY_SHADOWCBLAST2
and player.mo.state != S_PLAY_SUPER_TRANS1
and player.mo.state != S_PLAY_SUPER_TRANS2
and player.mo.state != S_PLAY_SUPER_TRANS3
and player.mo.state != S_PLAY_SUPER_TRANS4
and player.mo.state != S_PLAY_SUPER_TRANS5
and player.mo.state != S_PLAY_SUPER_TRANS6
and player.homing == 0
and not player.shadowspearshoot
and not player.actionstate
and not player.guard
and not player.shadow.battlehoming
and not (P_PlayerInPain(player) or (player.playerstate == PST_DEAD))
and not player.shadowinawall

S_StartSound(player.mo, sfx_shbost)
if not P_IsObjectOnGround(player.mo) and (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_SHADOWSPRINGFLIP
or (player.mo.state >= S_PLAY_SHADOWTRICK1 and player.mo.state <= S_PLAY_SHADOWTRICK8))
player.mo.state = S_PLAY_SHADOWAIRBOOST
player.pflags = $|PF_NOJUMPDAMAGE
player.mo.momz = 0
player.shadowspringed = false
end
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "shadow"
and player.powers[pw_justsprung]

player.shadowboost = false
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "shadow"
and player.homing

player.shadowboost = false
end
end)

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and player.mo.state == S_PLAY_SHADOWAIRBOOST

player.followmobj.sprite = SPR_NULL
end
end)

addHook("PlayerThink", function(player)
if player.shadowboostgauge == nil then player.shadowboostgauge = 100 return end
if player.mo.skin == "shadow"
and (player.cmd.buttons & BT_CUSTOM1)
and player.shadowboostgauge > 0
and not player.powers[pw_carry]
and player.mo.state != S_PLAY_SHADOWCSPEAR
and player.mo.state != S_PLAY_SHADOWCBLAST1
and player.mo.state != S_PLAY_SHADOWCBLAST2
and player.mo.state != S_PLAY_SUPER_TRANS1
and player.mo.state != S_PLAY_SUPER_TRANS2
and player.mo.state != S_PLAY_SUPER_TRANS3
and player.mo.state != S_PLAY_SUPER_TRANS4
and player.mo.state != S_PLAY_SUPER_TRANS5
and player.mo.state != S_PLAY_SUPER_TRANS6
and not player.shadowspearshoot
and not player.actionstate
and not player.guard
and player.homing == 0
and not player.shadow.battlehoming
and not (P_PlayerInPain(player) or (player.playerstate == PST_DEAD))
and not player.shadowinawall

player.shadowboost = true
local aura = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SHADOWBOOST)
aura.color = SKINCOLOR_RED
aura.angle = player.mo.angle
aura.target = player.mo
aura.tracer = player.mo
aura.scale = player.mo.scale
aura.blendmode = AST_ADD
player.charflags = $|SF_RUNONWATER
if not player.cmd.forwardmove
player.cmd.forwardmove = 60
end
if not (leveltime%4)
player.shadowboostgauge = $-1
end
if player.powers[pw_sneakers] or player.powers[pw_super]
P_Thrust(player.mo, player.mo.angle, 102*FRACUNIT - player.speed)
elseif not player.powers[pw_sneakers] and not player.powers[pw_super]
P_Thrust(player.mo, player.mo.angle, 80*FRACUNIT - player.speed)
end
end
end)

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and player.powers[pw_super]

player.shadowboostgauge = 100
end
end)

addHook("MobjThinker", function(mobj)
	if mobj and mobj.target
	   P_MoveOrigin(mobj, mobj.target.x, mobj.target.y, mobj.target.z)
	end
end, MT_SHADOWBOOST)

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and player.shadowboost
and P_IsObjectOnGround(player.mo)
and player.mo.state != S_PLAY_RUN
and not (player.pflags & PF_SPINNING)
and not player.shadowdrifting

player.mo.state = S_PLAY_RUN
end
end)

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and not (player.cmd.buttons & BT_CUSTOM1)
and player.shadowboost

player.shadowboost = false
player.charflags = $ & ~SF_RUNONWATER
end
end)

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"

player.shadowinawall = false
end
end)

addHook("MobjMoveBlocked", function(mobj, thing, line)
	if mobj and mobj.valid and line and line.valid
	and not thing and mobj.skin == "shadow" then
		mobj.player.shadowboost = false
		mobj.player.shadowinawall = true
	end
end, MT_PLAYER)

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and not player.shadowboost
and player.shadowboostgauge < 60
and not (leveltime%32)
and player.speed == 0
and P_IsObjectOnGround(player.mo)
and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT)

player.shadowboostgauge = $+2
end
end)

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and player.shadowboost
and player.shadowboostgauge == 0

player.shadowboost = false
player.charflags = $ & ~SF_RUNONWATER
end
end)

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and player.shadowboostgauge > 100

player.shadowboostgauge = 100
end
end)

addHook("PlayerCanDamage", function(player)
	if (player.mo and player.mo.skin == "shadow")
	and (player.shadowboost)
		return true
	end
end)

addHook ("PlayerThink",function(player)
if player.shadowprevrings == nil then player.shadowprevrings = 0 return end
if player.mo.skin == "shadow"
and player.rings > player.shadowprevrings

player.shadowboostgauge = $ + (player.rings - player.shadowprevrings)
player.shadowprevrings = player.rings
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "shadow"
and player.shadowprevrings > player.rings

player.shadowprevrings = player.rings
end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "shadow"
and (player.shadowboost)

player.powers[pw_strong] = $|STR_ANIM|STR_WALL|STR_SPIKE
end
end)

addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
if source.player and source.skin == "shadow" and target and target.flags & MF_ENEMY and target.health == 1
source.player.shadowboostgauge = $+8
return false
end
end)

-- Smooth Trail script by ffoxD.
-- Reusable, use with credit.
local function SmoothTrail(mo, trailmo, freq)
    -- Real Z momentum thingy plus leveltime checks.
    -- You can replace all this with mo.momz+mo.pmomz but that stays at 0 when on slopes and on ground.
    if not mo.prevz or not mo.prevleveltime or (mo.prevleveltime ~= leveltime - 1) then
       mo.prevz = mo.z
    end
    local rmomz = mo.z - mo.prevz
    mo.prevz = mo.z
    mo.prevleveltime = leveltime
    -- Handy local variables.
    local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), rmomz)
    local dist = (mospeed/freq)
    -- The loop, repeats until it spawns all the thok objects.
    for i = dist, 1, -1 do
        local spawnedmo = P_SpawnMobjFromMobj(mo, (mo.momx/dist)*i, (mo.momy/dist)*i, (rmomz/dist)*i, trailmo)
        spawnedmo.color = SKINCOLOR_RED
        spawnedmo.blendmode = AST_ADD -- blend
    end
end

addHook("PlayerThink", function(player)
    if player and player.valid and player.mo and player.mo.valid and player.mo.skin == "shadow" then
		if player.shadowboost then
            SmoothTrail(player.mo, MT_THOK, 4*FRACUNIT)
		end
    end
end)

addHook("PlayerThink", function(player)
    if player.mo and player.mo.valid and player.mo.skin == "shadow" then
        searchBlockmap("objects", function(refmo, mo)
            if (mo.type == MT_RING or mo.type == MT_COIN)
            and mo.health > 0
				if mo.target then
				local angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
				local vangle = R_PointToAngle2(0, 0, R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y), mo.target.z - mo.z)
					mo.momx = FixedMul(FixedMul(cos(angle), cos(vangle)), player.speed*3/2)
					mo.momy = FixedMul(FixedMul(sin(angle), cos(vangle)), player.speed*3/2)
					mo.momz = FixedMul(sin(vangle), player.speed*3/2)
				end
                if (P_AproxDistance(P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y),player.mo.z-mo.z) < 192*FRACUNIT
                or P_CheckSight(player.mo, mo)) and player.shadowboost then
                    mo.target = player.mo
                end
            end
        end, player.mo)
    end
end)

addHook("PlayerSpawn",function(player)
player.shadowboostgauge = 100
end)

